/*
 * Proiect PM 2015 === Joc X si 0 === 
 * Nume : Roaua Florina - Marinela
 * Grupa : 333CB
 */

#include <avr/io.h>
#include <util/delay.h>


int x,y;
int player = 0; /* poate fi player 0 sau 1 */
int grid[3][3];

void io_init()
{
	/* led-uri */
	DDRA = 255;
	DDRB = 255;
	DDRC |= ( 1 << PC0) | ( 1 << PC1) | ( 1 << PC6) ;
	
	/* butoane */
	DDRB &= ~(1 << PB7);
	DDRD &= ~( 1 << PD0) & ~( 1 << PD1) & ~( 1 << PD4) & ~( 1 << PD5);
	PORTB |= (1 << PB7);
	PORTD |= ( 1 << PD0) |( 1 << PD1) | ( 1 << PD4) | ( 1 << PD5);
	


}

void light_them_all()
{

	PORTA = 255;
	PORTB = 255;
	PORTC |= (1 << PC0) | (1 << PC1) | (1 << PC6);
}

void reset_grid()
{
	PORTA = PORTB = 0;
	PORTB |= (1 << PB7);
	PORTC = 0;
	x = y = 0;
	for(int i = 0; i < 3; i++)
		for(int j = 0; j < 3; j++)
			grid[i][j] = -1;
}

void check_win()
{
	if(grid[0][0] == grid[0][1] && grid[0][1] == grid[0][2] && grid[0][0] != -1)
	{	
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[1][0] == grid[1][1] && grid[1][1] == grid[1][2] && grid[1][0] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[2][0] == grid[2][1] && grid[2][1] == grid[2][2] && grid[2][0] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[0][0] == grid[1][0] && grid[1][0] == grid[2][0] && grid[0][0] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[0][1] == grid[1][1] && grid[1][1] == grid[2][1] && grid[0][1] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[0][2] == grid[1][2] && grid[1][2] == grid[2][2] && grid[0][2] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
	} else if(grid[0][0] == grid[1][1] && grid[1][1] == grid[2][2] && grid[0][0] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
		
	} else if(grid[2][0] == grid[1][1] && grid[1][1] == grid[0][2] && grid[2][0] != -1)
	{
		_delay_ms(1000);
		light_them_all();
		_delay_ms(1000);
		reset_grid();
	} 
}


void light()
{
	
	/* aprind doar galben */
	if(player == 0)
	{
		if(x == 0 && y == 0) {
			
			if(( PORTB & (1<<PB1)) == 0)
			{	
				PORTB |= (1 << PB0);
				grid[0][0] = 0;
			}
			else player--;
			
			
		} else if(x == 0 && y == 1) {
			
			if((PORTB & (1 << PB3)) == 0)
			{
				PORTB |= (1 << PB2);
				grid[0][1] = 0;
			}
			else player--;
			
		} else if(x == 0 && y == 2) {
		
			if((PORTB & (1 << PB5)) == 0) 
			{
				PORTB |= (1 << PB4);
				grid[0][2] = 0;
			} 
			else player--;
			
		} else if(x == 1 && y == 0) {
		
			if((PORTA & (1 << PA3)) == 0)
			{
				PORTA |= (1 << PA4);
				grid[1][0] = 0;
			}
			else player--;
		
		} else if(x == 1 && y == 1) {
		
			if((PORTB & (1 << PB6)) == 0) 
			{
				PORTA |= (1 << PA2);
				grid[1][1] = 0;
			}
			else player--;
			
		} else if(x == 1 && y == 2) {
			
			if((PORTC & (1 << PC0)) == 0)
			{
				PORTC |= (1 << PC1);
				grid[1][2] = 0;
			}
			else player--;
			
		} else if(x == 2 && y == 0) {
			
			if((PORTA & (1 << PA6)) == 0) 
			{
				PORTA |= (1 << PA7);
				grid[2][0] = 0;
			}
			else player--;
			
		} else if(x == 2 && y == 1) {
			
			if((PORTA & (1 << PA0)) == 0) 
			{
				PORTA |= (1 << PA5);
				grid[2][1] = 0;
			}
			else player--;
			
		} else if(x == 2 && y == 2) {
			
			if((PORTC & (1 << PC6)) == 0) 
			{
				PORTA |= (1 << PA1);
				grid[2][2] = 0;
			}
			else player--;
		} 
		
		
		
	} else { /* aprind doar portocaliu */
	
		
		if(x == 0 && y == 0) {
		
			if(( PORTB & (1<<PB0)) == 0)
			{	PORTB |= (1 << PB1);
				grid[0][0] = 1;
			}
			else player--;
			
		} else if(x == 0 && y == 1) {
		
			if((PORTB & (1 << PB2)) == 0) 
			{			
				PORTB |= (1 << PB3);
				grid[0][1] = 1;
			}
			else player--;
			
		} else if(x == 0 && y == 2) {
			
			if((PORTB & (1 << PB4)) == 0)
			{
				PORTB |= (1 << PB5);
				grid[0][2] = 1;
			}
			else player--;
			
		} else if(x == 1 && y == 0) {
			
			if((PORTA & (1 << PA4)) == 0)
			{
				PORTA |= (1 << PA3);
				grid[1][0] = 1;
			}
			else player--;
			
		} else if(x == 1 && y == 1) {
	
			if((PORTA & (1 << PA2)) == 0) 
			{
				PORTB |= (1 << PB6);
				grid[1][1] = 1;
			}
			else player--;
			
		} else if(x == 1 && y == 2) {
			
			if((PORTC & (1 << PC1)) == 0) 
			{
				PORTC |= (1 << PC0);
				grid[1][2] = 1;
			}
			else player--;
			
		} else if(x == 2 && y == 0) {
		
			if((PORTA & (1 << PA7)) == 0) 
			{
				PORTA |= (1 << PA6);
				grid[2][0] = 1;
			}
			else player--;
			
		} else if(x == 2 && y == 1) {
		
			if((PORTA & (1 << PA5)) == 0)
			{
				PORTA |= (1 << PA0);
				grid[2][1] = 1;
			}
			else player--;
			
		} else if(x == 2 && y == 2) {
			
			if((PORTA & (1 << PA1)) == 0) 
			{
				PORTC |= (1 << PC6);
				grid[2][2] = 1;
			}
			else player--;
		} 		
		
		
	}
	
	check_win();
	
}

void test_butoane()
{
	if ((PINB & (1 << PB7)) == 0 && ( PIND & (1 << PD0)) == 0)
	{	/* reset grid up + down */
		reset_grid();
		_delay_ms(1000);
	} else if ((PINB & (1 << PB7)) == 0) 
	{	/* buton down */
		y++;
		y %= 3;
		_delay_ms(1000);
	} else if (( PIND & (1 << PD0)) == 0)
	{	/* buton up */
		y--;
		if(y < 0)
			y = 2;
		y %= 3;
		_delay_ms(1000);
		
	} else if (( PIND & (1 << PD1)) == 0)
	{	/* buton left */
		x--;
		if( x < 0)
			x = 2;
		x %= 3;
		_delay_ms(1000);
	
	} else if (( PIND & (1 << PD4)) == 0)
	{
		/* buton ok */
		light();
		player++;
		player %= 2;
		_delay_ms(1000);
		
	} else if (( PIND & (1 << PD5)) == 0)
	{	/* buton right */
		x++;
		x %= 3;
		_delay_ms(1000);
	
	} 
	
}

void test_light()
{
	PORTC |= (1<<PC6);
}

int main()
{
    io_init();
	
	while(1)
	{
		test_butoane();
		//light_them_all();
		//_delay_ms(1000);
		//test_light();
	}
	
    return 0;
}

